#include "gfx.h"

/*

     modified for the plot_form variables

*/


int plot(int x,int y)
{
/*
2985 REM
2990 REM             PLOTTING ROUTINE  modified for plot_form
2995 REM

*/

char temp[50];
char ext[10];

        device = plot_device;/* only while plotting -- have redraw in
                                plot_form so need device = 1 there */

        if( device != 2)
        {
                strcpy(ext,".ps");

                if(encap == 1)
                {
                      strcpy(ext,".eps");
                }
        }
        else
        {
              strcpy(ext,".hgl");
        }

        if(strstr(plotfile,".") == NULL)
              strcat(plotfile,ext);

        if((fileprt=fopen(plotfile,"r")) != NULL ) /* fall thru unopened to below */
        {
               fclose(fileprt);
               if( yes_no_window(x,y,"File exists, Overwrite?",NO) != YES)
               {
                     device = 1;
                     get_size();   /* reset xl, xr, yu, yb to x window values */
                     return(-1);
               }
        }


     xl = 1607; xr = 10300; yu = 7650; yb = 1467;  /* hp plotter values */
                                                   /* also used for PS */

     sx = 100. * fabs(x_plot_size) * 1016. / ((float)xr - (float)xl);

     if( sx < 10. || sx > 100.)
     {
        info_window(x,y,"X plot size too large or too small");
        device = 1;
        get_size();   /* reset xl, xr, yu, yb to x window values */
        return(-1);

     }
     sy = 100. * fabs(y_plot_size) * 1016. / ((float)yu - (float)yb);

     if( sy < 10. || sy > 100.)
     {
        info_window(x,y,"Y plot size too large or too small");
        device = 1;
        get_size();   /* reset xl, xr, yu, yb to x window values */
        return(-1);

     }

     sx = sx / 100.;
     sy = sy / 100.;
     xr = (int)((float)xl + ((int)xr - (int)xl) * sx);
     yu = (int)((float)yb + ((int)yu - (int)yb) * sy);

     if(plot_open_device(plotfile) == -1)
     {
         info_window(x,y,"Cannot open output file");
         device = 1;
         get_size();   /* reset xl, xr, yu, yb to x window values */
         return(-1);  /* can't open file */
     }

        init_plot();

        if(plot_axes == 1)
        {
                box();
                show_ticks();
        }

        if(plot_curves == 1)
        {
                plotcurves(1);
        }

        if( plot_comments == 1)
        {
                put_comments();
        }

        penup();
        setpen(0);  /* for post does a showpage, in HPGL puts pen away */

        plot_close_device();

        sprintf(temp,"Plot written to %s ",plotfile);
        info_window(x,y,temp);

        device = 1;
        get_size();   /* reset xl, xr, yu, yb to x window values */
}

void set_font (int text)
{
/*
        set the text color and font for the text

        text = 0 is axes labels

        text = comment + 1 otherwise


*/

          setcolor(text_color[text]);

          currfont = text_font[text]+1;

}

void set_linetype (int seg)
{
/*

        set color,line width and type and pattern and pattern length
        from the arrays for the data segment.

*/
int t;
        setcolor(seg_color[seg]);
        patlen=(float)(seg_pat_len[seg]+1);
        t = seg_pattern[seg];
        ulinetype(&t);
        setpen(seg_width[seg]+1);

}

int init_plot()
{
/*
3485 REM
3490 REM            INITIALIZE PLOTTER using plot_form
3495 REM
*/
int t;
     initgraph(); linetype = 0;  patlen = 4;

     t=linetype;
     ulinetype(&t);

     t = 1;
     if(plot_axes == 0 )
     {
          if( (plot_curves == 1) || (plot_comments == 1 ))
           {
                 return(0);
          }
     }
     setpen(t);
}

void plotcurves (int i1)
{
/*
3185 REM
3190 REM            PLOT CURVES   modified for plot_form
3195 REM
*/
float xx,yy;
int x,y,xsave,ysave,tp,i,x0,y0,t,os,tx,ty,seg;
char tt[50];

     xx = xp[i1]; yy = yp[i1];
     x = x_coord(xx);
     y = y_coord(yy);

     xsave = x;  ysave = y;  tp = 0;

     seg = 0; /* current data segment */

     if(i1 == 1) s_set_color(i1);

for(i = i1;i<=np;i++)      /* main loop thru the data */
{

     if(device !=  1)    /* if not to the screen */
     {

          if((iv[i] <= 0 )||( i == i1))    /* set line type */
           {
                if(tp > 0 )   /* flush  the xy array */
                {
                    t = tp;
                    dline(t);
                    tp = 0;
                }
                set_linetype(seg);
                seg++;

          }
     }

     if( iv[i] != 1 )
     {
           if(tp > 0)     /* flush the buffer, next pt is not a line pt */
           {
                  t= tp; dline(t); tp = 0; penup();
           }
           goto skip;
      }
      else      /* we have a line point */
      {
           x0 = xsave; y0 = ysave;  x =x_coord( xp[i]);  y =y_coord( yp[i]);
           if( x == xsave &&  y == ysave)   /* ignore dupilcate pts */
           {
                 goto nextpt;
           }
           else
           {
                xsave = x;  ysave = y;
                wind(&x0, &y0, &x, &y, &os);  /* check pt is on plot */

                if( os == 1)
                {
                      if( tp > 0)   /* next pt off screen, flush */
                      {
                            t = tp; dline(t);  tp = 0; penup();
                      }
                      goto nextpt;
                }

                if(tp == 0)    /* first pt */
                {
                      xy[1] = x0; xy[2] = y0;  tp = 1;
                }

                if( os == -1)
                {
                      if(tp > 0)
                      {
                             tp = tp + 1; xy[2 * tp - 1] = x;  xy[2 * tp] = y;
                             t = tp; dline(t);  tp = 0;  penup();
                      }
                      goto nextpt;
                }

               tp = tp+ 1; xy[2 * tp - 1] = x;  xy[2 * tp] = y;

               if(tp >= 100)
               {
                     t = tp; dline(t);  tp = 0;
               }
               goto nextpt;
           }
      }
/* line 3290 */

skip:
     if( iv[i] <= 0)
     {
              s_set_color(i);
              x =x_coord( xp[i]);  y = y_coord(yp[i]);
              xsave = x;  ysave = y;
              goto nextpt;
     }
     os = chkpt(i); xsave = x;ysave = y;  /* is symbol on or off the screen? */

     if(os == 1) goto nextpt;

     if(iv[i] > 31)
     {
             currfont  = 2;
             tt[0] = (char)iv[i];
             tt[1] = '\0';
             t = 0;  tx = x;  ty = y;
             text(tx, ty, tt, t);
     }
     else
     {
            penup();  x = x_coord(xp[i]);  y = y_coord(yp[i]);
            t = iv[i] - 1;
                if(t < 10 )
                {
                         symbol(x, y, t);
                }
                else
                {
                        if(t==10) draw_arrow(x,y,i,0);
                        if(t==11) draw_arrow(x,y,i,1); /* filled arrow */
                }
            penup();
      }

nextpt:   /* line 3330 */

      t = t ; /* dummy line to avoid syntax error */

 }      /* next i */

     if(tp > 0)      /* flush the rest of the points in xy[]  */
     {
             t  = tp; dline(t);  tp = 0;
     }

     if(device ==  1)
     {
              t = 1; ulinetype(&t);
     }

     penup();
}

void put_comments()
{
/*
4396 REM
4397 REM             PLOT COMMENTS modified for plot_form
4398 REM
*/
int i,tx,ty,t;
char temp[100];

     penup();
     for(i= 0;i< num_comments;i++)
     {
          if(device != 1) set_font(i+1);

          tx =(int)( xl + (float)((com_col[i] - 14)*((int)xr-(int)xl)) / 67.) ;
          ty =(int)( yb + (1. - (float)(com_row[i])/20.) * ((int)yu - (int)yb));
          t=0;
          text(tx, ty, comments[i],t);
     }
}


void show_ticks()
{
/*
        does x - y axes labels, ticks and numbers

        modified for plot_form


*/
int tx,ty,xt,yt,sgx,sgy,tc,tu;
char temp[50];
int x_tick_len,y_tick_len;
float t,t1,t2,t3;
/*

                    PLOT AXES LABELS AND NUMBERS, TICKS/GRIDS

*/

if(device == 1)
{
        tc=1;
        x_color(&tc);
        titles();     /* already written put in sub */
}
else
{
     set_font(0); /* text = 0 is axes labels */

     ty = (int)yb - 587 * vp;
     tx = ((int)xr + (int)xl) / 2 - 52 * vp * get_strlen(xlabel);
     text(tx, ty, xlabel, 0);

     tx = (int)xl - 482 * vp;
     ty = ((int)yu + (int)yb) / 2 - 52 * vp * get_strlen(ylabel);
     text(tx, ty, ylabel, 90);

     convert(temp,ymax);
     tx = (int)xl - 161 * vp - 105 * vp * strlen(temp);
     ty = (int)yu - 60 + (1 - vp) * 52;
     text(tx, ty, temp, 0);

     convert(temp,ymin);
     tx = (int)xl - 161 * vp - 105 * vp * strlen(temp);
     ty = (int)yb - 60 + (1 - vp) * 52;
     text(tx, ty, temp,0);

     convert(temp,xmax);
     ty = (int)yb - 293 * vp + (1 - vp) * 54;
     tx = (int)xr - 52 * vp * (strlen(temp) - 1);
     text(tx, ty, temp,0);

     convert(temp,xmin);
     ty = (int)yb - 293 * vp + (1 - vp) * 54;
     tx = (int)xl - 52 * vp * (strlen(temp) - 1);
     text(tx, ty, temp, 0);
}
/*

                    PLOT Y=0 LINES

*/

        setcolor(0);  /* black ticks and x=0 y=0 lines */

if( (ymin*ymax < 0) && (yzero != 'n') && (yzero != 'N'))
{
   xy[1]= x_coord(xmin);
   xy[2]= y_coord(0);
   xy[3]= x_coord(xmax);
   xy[4]= y_coord(0);
   dline(2);
   penup();
/*
3915 IF ABS(y2 / (y2 - y1)) < .05 OR ABS(y1 / (y2 - y1)) < .05 THEN GOTO 3950
3925 'If dv != 1 Then tx = xl - 266 * vp: ty = y - 60 + (1 - vp) * 54: tt$ = "0": t = 0:  Else ty = y * 49 / 50: tx = xr / 10: tt$ = "0": t% = 0: Call text(tx%, ty%, tt$, ti%)
*/
}

/*

                    PLOT X=0 LINES

*/
if( (xmin*xmax < 0) && (xzero != 'n') && (xzero != 'N'))
{
   xy[1]= x_coord(0);
   xy[2]= y_coord(ymin);
   xy[3]= x_coord(0);
   xy[4]= y_coord(ymax);
   dline(2);
   penup();
/*
3963 IF ABS(x2 / (x2 - x1)) < .05 OR ABS(x1 / (x2 - x1)) < .05 THEN GOTO 4100
3965 'If dv != 1 Then ty = yb - 293 * vp + (1 - vp) * 54: tx = x - 35 * vp: tt$ = "0": t% = 0:CALL text(tx%, ty%, tt$, t%) ELSE ty% = 4 * yu / 25: tx% = x * .9875: tt$ = "0": t% = 0: CALL text(tx%, ty%, tt$, t%)
*/
}
/*

                    PLOT TICKS/GRIDS

*/
if( ticks != 'g' && ticks !='G' && ticks !='t' && ticks !='T' ) return;

if(ticks == 't' || ticks =='T' )
{
     /* old tx and ty */
     x_tick_len = ((int)xr - (int)xl) / 58;
     y_tick_len = (abs((int)yb - (int)yu) / 48) ;  /* should get signs ok */
}
else
{
    x_tick_len = ((int)xr - (int)xl);
    y_tick_len = abs((int)yb - (int)yu);  /* grids */
}

    if (( ticks == 't' || ticks == 'T') && (device == 2 || device == 3))
    {
             y_tick_len = x_tick_len;
    }

    sgx = sign(xmin) * sign(xmax);
    sgy = sign(ymin) * sign(ymax);

     if(s1 == 1)
     {
            log_ticks(2,xmin,xmax,xtick,x_tick_len,y_tick_len);
     }
     else
     {
           t2 = xtick; t1 = .99 * (xmax - xmin) + xmin;
           if( sgx < 0)
           {
                t = 0;
           }
           else t = xtick * (int)(xmin / xtick) + xtick;

           lin_ticks(2,t,t1,t2,x_tick_len,y_tick_len);

           if(sgx < 0)
           {
                 t1 = .01 * (xmax - xmin) + xmin; t2 = -xtick;  t = -xtick;
                 lin_ticks(2,t,t1,t2,x_tick_len,y_tick_len);
           }
     }

     if(s2 == 1)
     {
            log_ticks(3,ymin,ymax,ytick,x_tick_len,y_tick_len);
     }
     else
     {
           t2 = ytick; t1 = .99 * (ymax - ymin) + ymin;
           if( sgy < 0)
           {
                t = 0;
           }
           else t = ytick * (int)(ymin / ytick) + ytick;

           lin_ticks(3,t,t1,t2,x_tick_len,y_tick_len);

           if(sgy < 0)
           {
                 t1 = .01 * (ymax - ymin) + ymin; t2 = -ytick;  t = -ytick;
                 lin_ticks(3,t,t1,t2,x_tick_len,y_tick_len);
           }
     }

     if(ticks == 'g' || ticks == 'G')
     {
             penup();
             return;
     }

     if(s1 == 1)
     {
            log_ticks(4,xmin,xmax,xtick,x_tick_len,y_tick_len);
     }
     else
     {
           t2 = xtick; t1 = xmax - .01 * (xmax - xmin);
           if( sgx < 0)
           {
                t = 0;
           }
           else t = xtick * (int)(xmin / xtick) + xtick;

           lin_ticks(4,t,t1,t2,x_tick_len,y_tick_len);

           if(sgx < 0)
           {
                 t1 = .01 * (xmax - xmin) + xmin; t2 = -xtick;  t = -xtick;
                 lin_ticks(4,t,t1,t2,x_tick_len,y_tick_len);
           }
     }

     if(s2 == 1)
     {
            log_ticks(1,ymin,ymax,ytick,x_tick_len,y_tick_len);
     }
     else
     {
           t2 = ytick; t1 = ymax - .01 * (ymax - ymin);
           if( sgy < 0)
           {
                t = 0;
           }
           else t = ytick * (int)(ymin / ytick) + ytick;

           lin_ticks(1,t,t1,t2,x_tick_len,y_tick_len);

           if(sgy < 0)
           {
                 t1 = .01 * (ymax - ymin) + ymin; t2 = -ytick;  t = -ytick;
                 lin_ticks(1,t,t1,t2,x_tick_len,y_tick_len);
           }
     }


     if( ymin*ymax < 0.0 && yzero !='n' && yzero != 'n')
     {
         if(s1 == 1)
         {
                log_ticks(7,xmin,xmax,xtick,x_tick_len,y_tick_len);
         }
         else
         {
               t2 = xtick; t1 = xmin + .99 * (xmax - xmin);
               if( sgx < 0)
               {
                    t = 0;
               }
               else t = xtick * (int)(xmin / xtick) + xtick;

               lin_ticks(7,t,t1,t2,x_tick_len,y_tick_len);

               if(sgx < 0)
               {
                     t1 = .01 * (xmax - xmin) + xmin; t2 = -xtick;  t = -xtick;
                     lin_ticks(7,t,t1,t2,x_tick_len,y_tick_len);
               }
         }
     }

     if( xmin*xmax < 0.0 && xzero !='n' && xzero != 'n')
     {
          if(s2 == 1)
          {
                 log_ticks(8,ymin,ymax,ytick,x_tick_len,y_tick_len);
          }
          else
          {
                t2 = ytick; t1 = .99 * (ymax - ymin) + ymin;
                if( sgy < 0)
                {
                     t = 0;
                }
                else t = ytick * (int)(ymin / ytick) + ytick;

                lin_ticks(8,t,t1,t2,x_tick_len,y_tick_len);

                if(sgy < 0)
                {
                      t1 = .01 * (ymax - ymin) + ymin; t2 = -ytick;  t = -ytick;
                      lin_ticks(8,t,t1,t2,x_tick_len,y_tick_len);
                }
          }
     }

     penup();

}

void box()
{
/*
3525 REM
3530 REM            PLOT BOX WITH PEN #1 SLOW SPEED modified for plot_form
3535 REM
*/
int t;
char tt[50];

     if(device != 1)
     {
                  t=0;           /* default to thick solid line */
                  ulinetype(&t);
                  t=1;
                  setpen(t);
     }
     else
     {
           xlinetype(2);
     }
/*
        old single path box -- with setlinejoin changed need
        each line of box separate to get sharp corners

     xy[1] = xl; xy[2] = yb;  xy[3] = xr;  xy[4] = yb;
     xy[5] = xr; xy[6] = yu;  xy[7] = xl;  xy[8] = yu;
     xy[9] = xl; xy[10] = yb;  t = 5;  dline(t);
*/


     xy[1] = xl; xy[2] = yb;  xy[3] = xr;  xy[4] = yb;
     t = 2;  dline(t);

     xy[1] = xr;  xy[2] = yb; xy[3] = xr; xy[4] = yu;
     t = 2;  dline(t);

     xy[1] = xr; xy[2] = yu;  xy[3] = xl;  xy[4] = yu;
     t = 2;  dline(t);

     xy[1] = xl;  xy[2] = yu;
     xy[3] = xl; xy[4] = yb;  t = 2;  dline(t);

     t = 2;  setpen(t);

     if(device == 1) xlinetype(1);
}

void psbb(float *tllx, float *tlly, float *turx, float *tury)
{  
/*
	sets the bounding box size for GFx plots
*/	   

     if(rotp == 'n' || rotp == 'N')   /* ' figure out bounding box dimensions  */
     {
             *tllx = .5;
             *turx = ((float)((int)yu - (int)yb) / 1016.) + 2.5;
             *tlly = 10.5 - ((float)((int)xr - (int)xl) / 1016.) - 2.5;
             *tury = 10.;
     }
     else
     {
             *tllx = .5;
             *tlly = .5; /* was 1.0 */
             *turx = ((float)((int)xr - (int)xl) / 1016.) + 2.5;
             *tury = ((float)((int)yu - (int)yb) / 1016.) + 2.;  /* was + 2.5 */
     }
}     
