
/* x input windows defns */

#define BUTTONWIDTH 70
#define BUTTONHEIGHT 30


struct Inputs
{
        char text[100];  /* input text -- changed by get_input */
        char def[100]; /* default text */ 
        int row;  /* row location for input box */
        int col;  /* col location for input box */
        int maxlen;  /* max length of input string shown on screen */
        int disable;  /* =1 disables */
        int noedit;  /* =1 no edits allowed */
        char caption[50];  /* caption text */

} ;

struct Button
{
        int row;   /* location of center of each button */
        int col;   /* ditto */
        char text[20]; /* button text */
        int disable;  /* =1 disables button */
} ;

struct List
{
        char text[12][50];
        int list_len; /* number of items in the list */
        int row; /* row location of list box */
        int col; /* col location of list box */
        int maxlen; /* max len of text shown */
        int item; /* current item selected, 0 to list_len-1 */
        int disable; /* =1 disables */
        int def; /* default item */
        int numeric; /* =0 use text, =1 text is item +1, 
        	=2 text is item number */
        char caption[50];  /* list box caption */
} ;

struct InWin
{
        struct Inputs inputs[10]; /* input boxes structures */
        int num_inputs; /* number of input boxes */
        struct Button buttons[10]; /* button structures */
        int num_buttons; /* number of buttons */
        int button_width; /* button width */
        int button_height; /* button height */
        struct List lists[15]; /* list box structures */
        int num_lists; /* number of list boxes */
        int xsize;  /* width of input window */
        int ysize;  /* height of input window */
        char title[100]; /* window title */
        int default_button; /* = -1 no default = 0 to num_buttons - 1
        		       to mark default button on <cr> */
} inputwin[10];

/* Global X Variables */

#define XI_FONT "8x13"

int xi_fheight;      
int xi_fwidth,xi_fdescent;        
unsigned long xi_foreground, xi_background;
KeySym xi_key;
Cursor xi_cursor;
Font xi_font;
Colormap xi_colormap;
Display *xi_display;

#ifndef YES
	#define YES 1
#endif
#ifndef NO
	#define NO 0
#endif
#define DEFAULT 2

/* set noedit to this for passwd entries */
#define PASSWD 2

/* prototypes */

/* external routines: */

int xi_init(Display *,int,char *,char *,char *);
int open_input_window(Window *window,GC *gc,int xpos,int ypos,
		int xsize,int ysize,char *title);
int redraw_inwin(Window xwin,GC gc,int win);
int close_input_window(Window window,GC gc);
int info_window(int,int,char *);
int yes_no_window(int,int,char *,int );
int check_input(int win,int row,int col);
int get_input(Window xwin,GC gc,int in, int win);
int ftoa(char *result,char *fmt,float value);
int check_list(int win,int row,int col);
int check_button(Window xwin,GC gc,int x,int y,int win);

/* internal routines */

int redraw_info(Window xwin,GC gc,char *text,int w2xsize);
int yes_or_no(Window xwin,GC gc,int x,int y,int w2xsize);
int redraw_yesno(Window xwin,GC gc,char *text,int w2xsize,int def);
int remove_char(char *input,int at,int len);
int insert_char(char *input,int at,int len,char c);
int redraw_input(Window xwin,GC gc,int row,int col,char *input,int maxlen,int at,int noedit);
int draw_input(Window xwin,GC gc,int row,int col,char *input,int maxlen,char *caption);
int draw_input_box(Window xwin,GC gc,int row,int col,int maxlen,int line);
int draw_list_arrows(Window xwin,GC gc,int win,int list);
int draw_buttons(Window xwin,GC gc,int win);
int draw_button(Window xwin,GC gc,int y,int x,int width,int height,char *text,int highlight);
int which_button(int x,int y,int win);


		
